(** Time-stamp: <modified the 26/01/2009 (at 14:28) by Erwan Jahier> *)


(** All new identifier names ougth to be created via this module.  

    To avoid name clashes when inventing new identifiers, all user
    program idents have been prefixed by "_". Hence, the new idents
    generated here never begins with "_" and no clash is possible.
*)

(** [node_key nk name] returns a node ident that won't clash, using [name] or not. 

   The idea is the following: the caller propose a name to map the
   node key. But since that name may clash, we need to work a little bit
   more. This is the purpose of that function.
   
   nb : for a certain node key, it will always return the same string 
   (which means that [name] migth be ignored).
*)
val node_key: Eff.node_key -> string -> string


(** Dealing with fresh local (to the node) variable idents *)

(** Returns a fresh local var name *)
val new_local_var : string -> string (* mv new_var? *)

(** since those are local to the node, name can be re-used *)
val reset_local_var_prefix : string -> unit

(**  *)
val array_type : Eff.type_ -> string -> string
